import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsx as _jsx } from "react/jsx-runtime";

/* eslint-disable react/prop-types */
import { useRef } from 'react';
import MoleculeDropdownList from '@s-ui/react-molecule-dropdown-list';
import MoleculeInputTags from '@s-ui/react-molecule-input-tags';
import withClearUI from '../hoc/withClearUI';
var MoleculeInputTagsWithClearUI = withClearUI(MoleculeInputTags);

var MoleculeAutosuggestFieldMultiSelection = function MoleculeAutosuggestFieldMultiSelection(_ref) {
  var autoClose = _ref.autoClose,
      _ref$autoComplete = _ref.autoComplete,
      autoComplete = _ref$autoComplete === void 0 ? 'nope' : _ref$autoComplete,
      children = _ref.children,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      iconClear = _ref.iconClear,
      _ref$iconCloseTag = _ref.iconCloseTag,
      iconCloseTag = _ref$iconCloseTag === void 0 ? /*#__PURE__*/_jsx("span", {}) : _ref$iconCloseTag,
      id = _ref.id,
      innerRefInput = _ref.innerRefInput,
      inputMode = _ref.inputMode,
      isOpen = _ref.isOpen,
      onChange = _ref.onChange,
      onChangeTags = _ref.onChangeTags,
      onInputKeyDown = _ref.onInputKeyDown,
      onSelect = _ref.onSelect,
      onToggle = _ref.onToggle,
      placeholder = _ref.placeholder,
      refMoleculeAutosuggest = _ref.refMoleculeAutosuggest,
      required = _ref.required,
      size = _ref.size,
      tabIndex = _ref.tabIndex,
      _ref$tags = _ref.tags,
      tags = _ref$tags === void 0 ? [] : _ref$tags,
      type = _ref.type,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? '' : _ref$value;
  var MoleculeInputTagsRef = useRef();

  var handleMultiSelection = function handleMultiSelection(ev, _ref2) {
    var value = _ref2.value;
    var newTags = tags.includes(value) ? tags.filter(function (tag) {
      return tag !== value;
    }) : [].concat(tags, [value]);
    onChangeTags(ev, {
      value: '',
      tags: newTags
    });
    onSelect(ev, {
      value: '',
      tags: newTags
    });
    autoClose && onToggle(ev, {
      isOpen: false
    });
    refMoleculeAutosuggest.current.focus();
  };

  var handleChangeTags = function handleChangeTags(ev, _ref3) {
    var tags = _ref3.tags,
        value = _ref3.value;
    var isOpen = Boolean(value);
    onChangeTags(ev, {
      tags: tags
    });
    autoClose && onToggle(ev, {
      isOpen: isOpen
    });
    refMoleculeAutosuggest.current.focus();
  };

  var handleChange = function handleChange(ev, _ref4) {
    var value = _ref4.value;
    var isOpen = Boolean(value);
    onChange(ev, {
      value: value
    });
    autoClose && onToggle(ev, {
      isOpen: isOpen
    });
  };

  var handleClear = function handleClear() {
    onChange(null, {
      value: ''
    });
    onChangeTags(null, {
      tags: []
    });
  };

  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(MoleculeInputTagsWithClearUI, {
      autoComplete: autoComplete,
      disabled: disabled,
      iconClear: iconClear,
      id: id,
      innerRefInput: innerRefInput,
      inputMode: inputMode,
      isOpen: isOpen,
      isVisibleClear: tags.length,
      noBorder: true,
      onChange: handleChange,
      onChangeTags: handleChangeTags,
      onClick: onToggle,
      onClickClear: handleClear,
      onKeyDown: onInputKeyDown,
      placeholder: !tags.length ? placeholder : '',
      ref: MoleculeInputTagsRef,
      required: required,
      tabIndex: tabIndex,
      tags: tags,
      tagsCloseIcon: iconCloseTag,
      type: type,
      value: value
    }), /*#__PURE__*/_jsx(MoleculeDropdownList, {
      checkbox: true,
      highlightQuery: value,
      onSelect: handleMultiSelection,
      size: size,
      value: tags,
      visible: isOpen,
      children: children
    })]
  });
};

MoleculeAutosuggestFieldMultiSelection.displayName = 'MoleculeAutosuggestFieldMultiSelection';
export default MoleculeAutosuggestFieldMultiSelection;